/*global $ loadUpKeyboardDefaults showLoading hideLoading displayStatusModal*/
$(document).ready(function(){
    $('.dropdown').find("li").click(function(){
        var dropdown = $(this).parents('.dropdown, .dropup');
        var value = $(this).attr("data-dropdown-value");
        var input = $(dropdown).siblings('input');
        $(input).val(value);
        $(dropdown).children('.dropdown-toggle').text($(this).text());
        $(dropdown).children('.dropdown-toggle').trigger('change');
    });
    
    setupInputs();
      $.keyboard.keyaction.enter = function(base) {
        var value = base.$preview.val();
        var input = base.el;
        base.close();
        $(input).val(value);
    };
});


$('#mobile-notifications-toggle').change(function() {
    if($("#mobile-notifications-toggle").prop('checked')){
        $(".domain-section").show();
    }else{
        $(".domain-section").hide();
    }
});

function setMobileDomain(carrier){
    var mDomain = "";
    switch(carrier){
        case "AT&T":
            $("#mobile-domain").prop('disabled', true);
            mDomain = "txt.att.net";
            break;
        case "BoostMobile":
            $("#mobile-domain").prop('disabled', true);
            mDomain = "sms.myboostmobile.com";
            break;
        case "T-Mobile":
            $("#mobile-domain").prop('disabled', true);
            mDomain = "tmomail.net";
            break;
        case "US Cellular":
            $("#mobile-domain").prop('disabled', true);
            mDomain = "email.uscc.net";
            break;
        case "Verizon":
            $("#mobile-domain").prop('disabled', true);
            mDomain = "vtext.com";
            break;
        case "Virgin Mobile USA":
            $("#mobile-domain").prop('disabled', true);
            mDomain = "vmobil.com";
            break;
        case "Other":
            mDomain = customMobileDomain;
            $("#mobile-domain").prop('disabled', false);
            break;
    }
    $("#mobile-domain").val(mDomain);
}

$('.carrier-dropdown li a').on('click', function () {
    setMobileDomain($(this).text());
});

function getUser() {
    return  {
        firstname: $("#first-name").val(),
        lastname: $("#last-name").val(),
        email: $("#email").val(),
        phone: $("#phone").val(),
        carrier: $("#carrier").val(),
        seclevel: parseInt($("#level").val()),
        pin: $("#pin").val(),
        mobileNotifications : $("#mobile-notifications-toggle").prop('checked'),
        mobileDomain: $("#mobile-domain").val()
    };
}

function setupInputs() {
    var inputs = $('input.keyboard-input');
    for (var i = 0; i < inputs.length; i++){
        var id = $(inputs[i]).attr('id');
        loadUpKeyboardDefaults(id);
    }
}

function submitUser(settings) {
    var user = getUser();
    showLoading();
    $.ajax({
        method: settings.method,
        url: settings.url,
        data: JSON.stringify(user),
        success: function(data, textStatus, jqXHR) {
            hideLoading();
            displayStatusModal({
                title: data.Header,
                onClose: function() {
                    window.location = "/security/users";
                },
                show: true
            });
        },
        error: function(jqXHR, textStatus, errorThrown) {
            var response = jqXHR.responseJSON;
            displayStatusModal({
                title: response.Header,
                body: response.Message
            });
            hideLoading();
        }
    });
}

function validateEmail() {
  var $email = $("#email");
  var $tester = $("<input>");
  $tester.attr("type", "email");
  $tester.attr("class", "input-temp");
  $tester.val($email.val());
  var valid = $tester[0].checkValidity();
  $tester.remove();
  return valid;
}
